﻿#include "pch.h"
#include "windows.h"
#include "winnls.h"
#include "shobjidl.h"
#include "objbase.h"
#include "objidl.h"
#include "shlguid.h"
#include <ShlGuid.h>
#include <ShObjIdl_core.h>
#include "PepyakaShortcuts.h"

// ВНИМАНИЕ.
// Перед компиляцией в настройках проекта нужно установить:
// Свойства конфигурации -> Дополнительно -> Набор символов -> Использовать многобайтовую кодировку
// Для Clarion компилируем как Release x86
// В события сборки можно вставить код для копирования DLL в папку к программе
// copy $(IntermediateOutputPath)$(TargetFileName) "C:\Cw_App\Apps60\PepyakaShortcuts"

long CreateLink(const char* lpszPathObj, const char* lpszWorkPath, const char* lpszPathLink, const char* lpszDesc)
{
	HRESULT hres;
	IShellLink* psl;

	HRESULT hCoInit = 0;
	hCoInit = CoInitialize(nullptr);

	// Get a pointer to the IShellLink interface. It is assumed that CoInitialize
	// has already been called.
	hres = CoCreateInstance(CLSID_ShellLink, NULL, CLSCTX_INPROC_SERVER, IID_IShellLink, (LPVOID*)&psl);
	if (SUCCEEDED(hres))
	{
		IPersistFile* ppf;

		// Set the path to the shortcut target
		psl->SetPath(lpszPathObj);
		// Set working dir
		psl->SetWorkingDirectory(lpszWorkPath);
		// and add the description.
		psl->SetDescription(lpszDesc);
		//psl->SetShowCmd(SW_SHOWMINNOACTIVE);
		//TCHAR pszArgs[5] = TEXT("-min");
		//psl->SetArguments(pszArgs);

		// Query IShellLink for the IPersistFile interface, used for saving the
		// shortcut in persistent storage.
		hres = psl->QueryInterface(IID_IPersistFile, (LPVOID*)&ppf);
		if (SUCCEEDED(hres))
		{
			WCHAR pwsz[MAX_PATH];

			// Ensure that the string is Unicode.
			MultiByteToWideChar(CP_ACP, 0, lpszPathLink, -1, pwsz, MAX_PATH);

			// Save the link by calling IPersistFile::Save.
			hres = ppf->Save(pwsz, TRUE);
			ppf->Release();
		}
		psl->Release();
	}

	CoUninitialize();

	return hres;
}